package{
	import flash.display.MovieClip
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.TextFieldAutoSize;
	import flash.events.MouseEvent;
	import Bind;
	import TestButton;

	[SWF(width='650', height='130', backgroundColor='#ffffff', frameRate='60')]
	
	public class Main extends MovieClip{
		private var bindBtn:TestButton = new TestButton();
		private var unbindBtn:TestButton = new TestButton();
		private var clickBtn:TestButton = new TestButton();
		
		public var format:TextFormat = new TextFormat("Courier", 16, 0x333333);
		private var binder:Bind = new Bind();
		private var clickCounter:TextField = new TextField();
		private var counterFormat:TextFormat = new TextFormat("Arial", 14, 0x000000);
		private var clicks:int = 0;
		private var status:String = "Bound (Click working)";
		private var statusField:TextField = new TextField();
		private var code:String = "binder.bind(clickBtn,{click:clickHandler, over:overHandler, out:outHandler});";
		private var codeField:TextField = new TextField();
		
		public function Main(){
			addChild(clickBtn).y = 10;
			addChild(unbindBtn).y = 90;
			addChild(bindBtn).y = 50;
			clickBtn.x = unbindBtn.x = bindBtn.x = 10;
			bindBtn.label = "Bind";
			unbindBtn.label = "Unbind";
			clickBtn.label = "Click";
			
			binder.bind(clickBtn,{click:clickHandler, over:overHandler, out:outHandler});	
			binder.bind(unbindBtn,{click:unbindClick, over:overHandler, out:outHandler});
			binder.bind(bindBtn,{click:bindClick, over:overHandler, out:outHandler});
			
			addChild(codeField);
			codeField.y = 95;
			addChild(statusField);
			statusField.y = 55;
			addChild(clickCounter);
			clickCounter.y = 15;
			
			statusField.selectable = clickCounter.selectable = false;
			codeField.autoSize = statusField.autoSize = clickCounter.autoSize = TextFieldAutoSize.LEFT;
			clickCounter.x = statusField.x = codeField.x = 120;
		
			updateClicks();
			getStatus();
		}		
		
		private function clickHandler(event:MouseEvent):void{
			clicks++;
			updateClicks();
		}
		
		private function overHandler(event:MouseEvent):void{
			format.color = 0xffffff;
			event.target.getChildAt(0).setTextFormat(format);
		}
		
		private function outHandler(event:MouseEvent):void{
			format.color = 0x333333;
			event.target.getChildAt(0).setTextFormat(format);
		}
		
		private function updateClicks():void{
			clickCounter.text = clicks + " clicks";
			clickCounter.setTextFormat(counterFormat);
		}
		
		private function unbindClick(event:MouseEvent):void{
			clickBtn.alpha = .5;
			binder.unbind(clickBtn,{click:clickHandler, over:overHandler, out:outHandler});	
			status = "Unbound (Click not working)";
			code = "binder.unbind(clickBtn,{click:clickHandler, over:overHandler, out:outHandler});";
			getStatus();
		}
		
		private function bindClick(event:MouseEvent):void{
			clickBtn.alpha = 1;
			binder.bind(clickBtn,{click:clickHandler, over:overHandler, out:outHandler});	
			status = "Bound (Click working)";
			code = "binder.bind(clickBtn,{click:clickHandler, over:overHandler, out:outHandler});";
			getStatus();
		}
		
		private function getStatus():void{
			codeField.text = "Code:"+code;
			statusField.text = "Status:"+status;
			codeField.setTextFormat(counterFormat);
			statusField.setTextFormat(counterFormat);
		}
	}
	
}